$SAFE = 3

# ***** Code Fixes *****
# Overrides some methods in the base class String.
class String
	alias orig_to_f to_f
	alias orig_to_i to_i
	alias string_format %
	def to_f
		self[0] = '-' if (self[0] == '(')
		delete(',$()').orig_to_f
	end
	def to_i
		self[0] = '-' if (self[0] == '(')
		delete(',$()').orig_to_i
	end
	def %(arg)
		if (index('f') != nil and !arg.kind_of?(Array))
			value = arg.to_f
			string_format(value < 0.0 ? value - 0.00000001 : value + 0.00000001)
		else
			string_format(arg)
		end
	end
end

# ***** Form Data *****
class DCBA4321
	def initialize()
		# Freeze values that are overriden by the user.
		#@array = [ ['John', '12.43'], ['123-45-98756'], [], ['50', '$23,021.20', 'two'] ]
		@page_array = [['box1_1','']]
		# Alternate hashed lookup table for field names.
		@field_hash = {} #{ '1:1' => [0,0], 'box1_2' => [0,1], 'AGI' => [3,1] }
		# Holds the forms current rounding mode.
		@rounding = '%0.2f'
	end
	def rounding
		@rounding		
	end
	def [] ( key )
		if key.class == Fixnum
			@page_array[ key ]
		elsif key.class == String
			value = @field_hash[ key ]
			@page_array[value[0]][value[1]] if (value != nil)
		else
			nil
		end
	end
	def []= ( key, rhs )
		value = @field_hash[ key.to_s ]
		@page_array[value[0]][value[1]] = rhs if (value != nil)
	end
	def pages ()
		@page_array.size
	end
	def output
		@field_hash.each { |key, value|
			print key.to_s + "\x02" + @page_array[value[0]][value[1]].to_s + "\x03\n"
		}
	end
end

# *** Begin Calculations ***
class DCBA4321
	# Define which fields are 'green' calcs.
	def define_formula_fields
		@formula = [ 'box1_1', 'two' ]
	end
end

form = DCBA4321.new
form.define_formula_fields

form.output

#form['box1_2'] = 70

form.output

form[0][1] = 'Monica'

form.output